<%@ page errorPage="/resources/jsp/errorpage.jsp" %>
<%@ page contentType="text/html" %>

<%@ page import="java.util.Enumeration" %>
<%@ page import="com.tarantella.tta.webservices.IAttributeNames" %>
<%@ page import="com.tarantella.tta.webservices.IConstants" %>
<%@ page import="com.tarantella.tta.webservices.IConstantsGUI" %>
<%@ page import="com.tarantella.tta.webservices.IConstantsXML" %>
<%@ page import="com.tarantella.tta.webservices.client.views.DataRequest" %>
<%@ page import="com.tarantella.tta.webservices.client.views.SessionBean" %>

<%-- Webtop Session Management --%>
<%@ include file="/resources/jsp/utilities.jsp" %>
<%@ include file="/resources/jsp/localeutils.jsp" %>
<%
   pageContext.setAttribute(PARAM_SESSION_AUTHENTICATE, "false", PageContext.REQUEST_SCOPE);
%>

<%
   // initialise class variables
   setContext(request, response, pageContext);
   setLoginGifPath(pageContext, getContextPath(request) + "/resources/images/login/");
%>

<!DOCTYPE html>
<html lang="<%=getHtmlLang(pageContext)%>">
<head>
<title>Oracle Secure Global Desktop</title>
<meta http-equiv="Content-Type" content="text/html; charset=<%=getHtmlCharSet()%>">
<meta http-equiv="X-UA-Compatible" content="requiresActiveX=true, IE=Edge" />
<link rel="stylesheet" type="text/css" href="<%= getDialogStyleSheet(request, pageContext) %>" />
<link rel="stylesheet" type="text/css" href="<%= getButtonStyleSheet(pageContext) %>">
<link rel="stylesheet" type="text/css" href="<%= getStyleSheet(request, pageContext) %>">

<meta name="apple-mobile-web-app-title" content="Oracle SGD">
<link rel="apple-touch-icon-precomposed" href="/sgd/h5c/img/icon.png" />
<link rel="apple-touch-icon-precomposed" sizes="72x72" href="/sgd/h5c/img/icon.png" />
<link rel="apple-touch-icon-precomposed" sizes="114x114" href="/sgd/h5c/img/icon@2x.png" />
<link rel="apple-touch-icon-precomposed" sizes="144x144" href="/sgd/h5c/img/icon144.png" />

<%
   response.setHeader("Cache-Control","no-cache"); //HTTP 1.1^M
   response.setHeader("Pragma","no-cache"); //HTTP 1.0^M
   response.setDateHeader ("Expires", 0); //prevents caching at the proxy server^M

   SessionBean ttaSessionObject = getSGDSession(pageContext, SESSION_OBJ);
   String host = null;
   if (ttaSessionObject != null)
      host = (String) ttaSessionObject.getAttribute(IConstantsXML.NAME_CONNECTION_ATTRS, IAttributeNames.HOST);
   if (host == null)
      host = "";

    String[] ttaMessages = (String[])pageContext.getAttribute(MESSAGES, PageContext.REQUEST_SCOPE);


String loginAttemptURL = getContextPath(request) + "/authentication/ttaAuthentication.jsp";
DataRequest[] dataReqs = (DataRequest[])pageContext.getAttribute(LOGIN_REQUESTS, PageContext.SESSION_SCOPE);
%>


<script type="text/javascript">
function checkEnter() 
{
    if(window.event) {
      if (window.event.keyCode == 13) {
        document.getElementById('login').click();
      }
    }
}

function getIEVersion()
{
     var version = -1; 
     if (navigator.appName != 'Microsoft Internet Explorer') 
        return version;

     var agent = navigator.userAgent;
     var re = new RegExp("MSIE ([0-9]{1,}[\.0-9]{0,})");
     if (re.exec(agent) != null)
        version = parseFloat(RegExp.$1);
          
     return version;
}


/* This function adds event handlers to controls in IE8
   so that submit on enter works
   see CR:6969452 

   IE detection based on : Giorgio Sardo's blog entry at 
   http://blogs.msdn.com/b/giorgio/archive/2009/04/14/how-to-detect-ie8-using-javascript-client-side.aspx
 */  
function fixIE8()
{
     var version = getIEVersion();
     if (version == -1 || version > 8.0)
        return;
<%
      for (int i=0; i<dataReqs.length; i++) {
%>
         var el = document.getElementById("<%=dataReqs[i].getFeature(IConstantsGUI.PROMPT, "data:") %>" );
         el.attachEvent("onkeydown", checkEnter); 

<%  
         if(dataReqs[i].getFeature(IConstantsGUI.CONFIRM, false)) {
%>
         var elConfirm = document.getElementById("<%= IConstantsGUI.CONFIRM + dataReqs[i].getAttributeName() %>" );
         elConfirm.attachEvent("onkeydown", checkEnter); 
<%
         }
      }
%>

}

function showTuring() {
  var turingDiv = document.getElementById("divTuring");
  var username = document.getElementById("Username").value;
  if (username == "") {
    turingDiv.style.display = "none";
  } else {
    turingDiv.style.display = "";
    var turingImg = document.getElementById("imgTuring");
    turingImg.style.display = "";
    turingImg.src = "/sgd/turing.jsp?username=" + username + "&random=" + Math.floor(Math.random() * 10000);
  }
}

function showOtc() {
  // Insert OTC field and label in a row above the login button
  // Make sure it's not already there.
  var loginBtn = document.getElementById('login');
  if (loginBtn) {
    var sibling = loginBtn.parentNode;
    var container = sibling.parentNode;
    while (sibling.className != 'dialogBody') {
      sibling = container;
      container = container.parentNode;
    }
    sibling = sibling.nextSibling;
    var otcRow = document.getElementById('trOtc');
    var turingDiv = document.getElementById("divTuring");
    var username = document.getElementById("Username");
    if (!turingDiv) {
      turingDiv = document.createElement("div");
      turingDiv.id = 'divTuring';
      var turImg = document.createElement("img");
      turImg.id = "imgTuring";
      turingDiv.appendChild(turImg);
      var turBtn = document.createElement("input");
      turBtn.type = "button";
      turBtn.className = "button-grey";
      turBtn.value = "Refresh Image";
      turBtn.onclick = showTuring;
      turingDiv.appendChild(document.createElement("br"));
      turingDiv.appendChild(turBtn);
      container.insertBefore(turingDiv, sibling);
      if (username.value == "") {
        turingDiv.style.display = "none";
      } else {
        turingDiv.style.display = "";
        showTuring();
      }
      username.onblur = showTuring;
    }
  }
}

function showPage() {
   if ( self == top ) {
     document.getElementById('errorpage').style.display='none';
     document.getElementById('realpage').style.visibility='visible';
   } else {
     top.location=self.location;
   }
  showOtc();
}

</SCRIPT>

</head>


<%
if (dataReqs == null)
{
%>
<body class="dialogPageBackground" onload="showPage();">
<div id="errorpage">
  <%@ include file="/resources/jsp/erroraccessprevented.jsp" %>
</div>

<div id="realpage" style="visibility:hidden;">
  <%@ include file="/resources/jsp/errornodatareqs.jsp" %>
   <STRONG><%=getWebtopString(pageContext, "I0_ErrNoDataRequests")%></STRONG>
</div>
<%
}
else
{
    int nfocus = 0;
    if ( dataReqs.length>0 ) {
        if ( dataReqs[0].getFeature(IConstantsGUI.VALUE, "").length() > 0 )
            nfocus=1;
    }

    // Set autocomplete parameter
    String autoCompleteParameter = "";
    if (Boolean.parseBoolean(getServletContext().getInitParameter(DISABLE_LOGIN_AUTOCOMPLETE)))
    {
      autoCompleteParameter = " autocomplete=\"off\"";
    }
%>


<body class="dialogPageBackground" onLoad="showPage(); document.auth.<%= dataReqs[nfocus].getAttributeName() %>.focus();">
<div id="errorpage">
  <%@ include file="/resources/jsp/erroraccessprevented.jsp" %>
</div>

<div id="realpage" style="visibility:hidden;">

<div align="center">
   <div class="dialogTop">
      <div id="dialogHeaderWrapper">
         <h1 id="dialogHeader" > Secure Global Desktop </h1>
      </div>
   </div>

   <div class="dialogBody">
      <div class="dialogContent">
         <form name="auth" action="<%= response.encodeURL(loginAttemptURL) %>" method=POST<%= autoCompleteParameter %>>
         <table class="dsR2" border="0" cellspacing="8" cellpadding="0">
<%
         for (int i=0; i<dataReqs.length; i++) {
%>
         <tr>
            <td><label for="<%= dataReqs[i].getFeature(IConstantsGUI.PROMPT, "data:") %>"><%= dataReqs[i].getFeature(IConstantsGUI.PROMPT, "data:") %></label></td>
            <td>
            <input id="<%= dataReqs[i].getFeature(IConstantsGUI.PROMPT, "data:") %>" 
                   alt="<%= dataReqs[i].getFeature(IConstantsGUI.PROMPT, "data:") %>" 
                   name="<%= dataReqs[i].getAttributeName() %>" 
                   type="<%= dataReqs[i].getFeature(IConstantsGUI.TYPE, "text") %>" 
                   size="<%= dataReqs[i].getFeature(IConstantsGUI.SIZE, 15) %>" 
                   maxlength="<%= dataReqs[i].getFeature(IConstantsGUI.MAXLENGTH, 100) %>" 
                   value="<%= htmlEscape(dataReqs[i].getFeature(IConstantsGUI.VALUE, "")) %>" 
                   autocapitalize="off"
                   autocorrect="off"
                   spellcheck="false"
                   style="width:150px">
            </td>
         </tr>
<%
         // Do we need to confirm?
         if(dataReqs[i].getFeature(IConstantsGUI.CONFIRM, false)) {
%>
         <tr>
            <td><label for="<%= dataReqs[i].getFeature(IConstantsGUI.PROMPT, "") %>">
                       <%=getWebtopString(pageContext, "I0_LoginConfirm")%> 
                       <%= dataReqs[i].getFeature(IConstantsGUI.PROMPT, "") %>
                </label>
             </td>
             <td>
             <input id="<%= IConstantsGUI.CONFIRM + dataReqs[i].getAttributeName() %>"
                    name="<%= IConstantsGUI.CONFIRM + dataReqs[i].getAttributeName() %>" 
                    type="<%= dataReqs[i].getFeature(IConstantsGUI.TYPE, "text") %>" 
                    size="<%= dataReqs[i].getFeature(IConstantsGUI.SIZE, 15) %>" 
                    maxlength="<%= dataReqs[i].getFeature(IConstantsGUI.MAXLENGTH, 100) %>" 
                    value="<%= htmlEscape(dataReqs[i].getFeature(IConstantsGUI.VALUE, "")) %>" 
                    style="width:150px" >
             </td>
         </tr>
<%
         }
         } //end of the for loop
%>

         <tr>
            <td></td>
            <td>
               <input id="login" alt="<%=getWebtopString(pageContext, "I0_Login")%>" 
                                 type="submit" name="login" class="button-grey"
                                 value="<%=getWebtopString(pageContext, "I0_Login")%>" >
            </td>
         </tr>
<%
         if (ttaMessages != null) {
            for (int i=0; i<ttaMessages.length; i++) {
%>
               <tr><td colspan="2"><p class="boldGray"><%= getStringByCharSet(ttaMessages[i]) %></p></td></tr>
<%
            }
         } 
%>
         </table>
         </form>
      </div>
   </div>
   <div class="dialogBottom"></div>
</div>
</div>
<%
 }
%>
</body>
</html>
